import JMyron.*;

int numBalls = 0;
int numPoints = 0;
//int numPegs = 24;
float e = 0.93;
float gravity = 0.1;
float friction = 0.002;
Point2d[] pnts = new Point2d[numPoints];
Ball[] balls = new Ball[numBalls];

// Capture Blocks//////////////////////////////////
int px;
int py;
int oldpx;
int oldpy;
int lx;
int ly;
int[][][] points;
int[][][] laserPoints;
int[] cameraImage;

JMyron m;//a camera object
JMyron old; 

int count = 1;

int cam_width = 1024;
int cam_height = 768;

int shiftX=183, shiftY=125;
float scaleFactor=2;
boolean drawn = true;
//////////////////////////////////////////////////////

void setup()
{
  
    
  size(1024, 768);
  frameRate(120);
  
  // Capture Blocks /////////////////////////////////////////
  // Initialize built-in isight
  //old = new JMyron();
  //old.start(1,1);
  
  m = new JMyron();//make a new instance of the object
  m.start(cam_width,cam_height);//start a capture at 320x240
  
  takeCameraImage();
  displayCameraImage();
  setPointArray();
  /////////////////////////////////////////////////////////////

  smooth();
  noStroke();
  //initialize balls array with loop here
  for( int i = 0; i < numBalls; i++) {
    //balls[i] = new Ball(90+i*90, random(0, 90), random(-5, 5), random(10, 20));
    balls[i] = new Ball(random(width), random(0, 90), 0, 15);
  }
  for( int i = 0; i < numBalls; i++) {
    while (touching( balls, i )) {
      //x,y,vx,radius
      balls[i] = new Ball(random(width), random(0, 90), 0, 15);
    }
  }
}

void mousePressed() {
  takeCameraImage();
  setPointArray();
  drawn=false;
}

void draw()
{
  background(255);
  for( int i = 0; i < numPoints; i++) {
    pnts[i].display();
  }
  //put ball movement and collision stuff here
  for( int i = 0; i < numBalls; i++ ) {
    balls[i].motion();
    balls[i].collide( balls, i+1, numBalls );
    balls[i].pcollide( pnts );
    balls[i].display();
    //balls[i].dispVel();     //displays the velocity vector for curiosities sake
    noOverlap( balls, i);
  }
  
  // Camera Capture
    //background(255,255,255);
  
  // Display the Image Last Recorded By the Camera
  //displayCameraImage();
  
  // Draw Point For Every Point in the points array 
  noFill();
  stroke(0, 300, 200); // green
  //stroke(255,255,0); // yellow
  for(int i=0; i< numPoints; i++){
    pnts[i].display();
  }
  
 if(drawn){ 
    /*ly++;
    stroke(0,0,0);
    fill(0);
    ellipse(lx, ly, 10, 10);*/
  }else{
    drawLaserBall();
    drawn = true;
  }
}

void drawLaserBall(){
  if (laserPoints.length!=0 && laserPoints!=null){
    if (laserPoints[0].length!=0 && laserPoints[0]!=null){
      Ball[] temp = new Ball[numBalls];
      for(int i=0; i<numBalls; i++){
        temp[i]=new Ball(balls[i]);
      }
      numBalls++;
      balls = new Ball[numBalls];
      for(int i=0; i<(numBalls-1); i++){
        balls[i]=new Ball(temp[i]);
      }
      balls[numBalls-1]=new Ball(laserPoints[0][0][0],laserPoints[0][0][1],0,15);
    }
  }
}

void takeCameraImage() {
    m.update();
    cameraImage = m.image(); //get the normal image of the camera
}

void displayCameraImage() {
  m.update();
  loadPixels();
  for(int i=0; i<cam_width*cam_height; i++){
    pixels[(i%cam_width)+(width*((int)(i/cam_width)))] = cameraImage[i];
  }
  updatePixels();
  
}

void setPointArray(){
  // Track Blocks
  m.minDensity(1);
  //m.trackNotColor(0,0,0,255);
  m.trackColor(0,0,0,100);

  m.findGlobs(1);
  m.update();
  points = m.globEdgePoints(2);
  numPoints = 0;
  for(int i=0; i< points.length; i++){
    if(points[i]!= null){
       numPoints+=points[i].length;
    }
  }
  pnts = new Point2d[numPoints];
  int indexP=0;
  for(int i=0; i< points.length; i++){
    if(points[i]!= null){
      for(int ii=0; ii < points[i].length;ii++){
        pnts[indexP] = new Point2d((int)((points[i][ii][0]-shiftX)*scaleFactor),(int)((points[i][ii][1]-shiftY)*scaleFactor));
        indexP++; 
        points[i][ii][0] = (int)((points[i][ii][0]-shiftX)*scaleFactor);
        points[i][ii][1] = (int)((points[i][ii][1]-shiftY)*scaleFactor);
      }
    }
  }
  
   // Track Laser
  m.minDensity(1);  //minimum density - you'll need to tweak this, probably.
  m.trackColor(255,255,255,50);
  m.findGlobs(1);
  m.update();
  laserPoints = m.globEdgePoints(2);
  for(int i=0; i< laserPoints.length; i++){
    if(laserPoints[i]!= null){
      for(int ii=0; ii < laserPoints[i].length;ii++){
        laserPoints[i][ii][0] = (int)((laserPoints[i][ii][0]-shiftX)*scaleFactor);
        laserPoints[i][ii][1] = (int)((laserPoints[i][ii][1]-shiftY)*scaleFactor);
      }
    }
  }
}





boolean touching( Ball[] balls, int target ) {
  for( int i = 0; i < numBalls; i++) {
    if ( i != target ) {
      //calculate the distance to ith ball
      float distance = balls[target].distance( balls[i] );
      float minDist = balls[i].rad + balls[target].rad;
      
      if( distance < minDist ) {
        return true;
      }
    }
  }
  return false;
}// End function touching

void noOverlap( Ball[] balls, int target ) {
  boolean changed = false;
  while (changed) {
  for( int i = 0; i < numBalls; i++) {
    if ( i != target ) {
      //calculate the distance to ith ball
      float distance = balls[target].distance( balls[i] );
      float minDist = balls[i].rad + balls[target].rad;
      
      if( distance < minDist ) {
        changed = true;
        float angle = balls[target].angle(balls[i]);
        balls[target].x = minDist * cos(angle);
        balls[target].y = minDist * sin(angle);
      }
    }    
  }// End for
  }// End while  
}// End function noOverlap
